
%% Let's start with reading an image and showing it

im = imread('owl.png') ;
imshow(im) ;
pause() ;

% 
%% Tutorial 1.1 -----------------------------------------------------------
% Now let's blur the image with a gaussian filter with three different sigmas
for s=3:2:7
  
  
  sigma = s ;


  r = ceil(3 * sigma) ;
  
  % generate 2D gaussian filters for sigma = s
  g = zeros(2*r+1,2*r+1) ;
  
  for y=-r:1:r
      for x=-r:1:r
          % HERE GENERATE GAUSSIAN FILTERS
%           g(y,x) = 
%           (since MatLab arrays start at 1, fill in entry g(y+r+1,x+r+1))
      end
  end
      
  
  
  % show gaussian filter
  figure(1), imagesc(g) ;
  
  tic 
  
  % FILL correlationdot2d.m function
  fprintf('Running correlation2d for sigma %d\n',s) ;
  imsmooth = correlation2d(im,g) ;
  
  toc 
  
  
  
  % SHOW the smoothed image
  figure(2), imshow(uint8(imsmooth)) ;
  title(sprintf('owlGaussian%d.png',s)) ;
  pause() ;
  imwrite(uint8(imsmooth),sprintf('owl_gaussian%d.png',s)) ;
  
end

%% Tutorial 1.2 -----------------------------------------------------------
% NOW can you write correlation2d with a dot product "correlationdot2d.m"?
close all ;
for s=3:2:7
  
  
  sigma = s ;


  r = ceil(3 * sigma) ;
  g = zeros(2*r+1,2*r+1) ;

  % generate 2D gaussian filters for sigma = s
  % copy paste from 1.1

  tic 
  fprintf('Running correlation2d for sigma %d\n',s) ;
  % FILL correlationdot2d.m function
  imsmooth1 = correlation2d(im,g) ;
  toc
  
  tic
  imsmooth2 = correlationdot2d(im,g) ;
  fprintf('Running correlationdot2d for sigma %d\n',s) ;
  toc
  
  % do they have the same value?
  if any(abs(imsmooth1(:)-imsmooth2(:))>1e-5)
    warning('image values are different!') ;
  end
    
  
  % SHOW the smoothed image
  imshow(uint8([imsmooth1, imsmooth2])) ;
  title(sprintf('owlGaussian%d.png',s)) ;
  pause() ;
end



%% Tutorial 1.3 -----------------------------------------------------------
% Let's use correlationdot2d to find Waldo
close all ;

template = (imread('puzzle5_waldo.jpg')) ;
im = (imread('puzzle5.jpg')) ;

figure(1), imshow(im) ;
title('Image') ;
figure(2), imshow(template) ;
title('Template') ;
pause() ;

% let's convert them to gray scale 
imgray =  rgb2gray(im) ;
templategray = rgb2gray(template) ;

result = correlationdot2d(imgray,templategray) ;

figure(3), surf(result), shading flat, title('Cross Correlation Result') ;

% find the best match
[ypeak, xpeak] = find(result==max(result(:))); 

yoffSet = ypeak;
xoffSet = xpeak;

% draw a rectangle
h = imrect(gca, [xoffSet+1, yoffSet+1, size(template,2), size(template,1)]);
mask = zeros(size(im),'uint8') ;
mask(yoffSet:yoffSet+size(template,1)-1,xoffSet:xoffSet+size(template,2)-1, :) = 1 ;

figure(4), imshow(im .* mask) ;
title('Is it Waldo? Maybe not!') ;
pause() ;



%% Tutorial 1.4 -----------------------------------------------------------
% Let's use normalizedcorrelationdot2d to find Waldo once again

result = normalizedcorrelation2d(imgray,templategray) ;
figure(3), surf(result), shading flat, title('Normalized Cross Correlation Result') ;

% find the best match
[ypeak, xpeak] = find(result==max(result(:))); 

yoffSet = ypeak;
xoffSet = xpeak;

% draw a rectangle
imfound = im ;

mask = zeros(size(im),'uint8') ;
mask(yoffSet:yoffSet+size(template,1)-1,xoffSet:xoffSet+size(template,2)-1, :) = 1 ;

figure(4), imshow(im .* mask) ;

title('Is it Waldo?') ;




